// XZR (X1) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x400*5*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{

	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[11];
	int i;
	int dn=0;
	unsigned char id1[] = "XZR-Rhodes   Sys ";

	// Disk 1
	struct fpos md1a[] =
	{
		{ 0x30, 0x01, 0x0400 },	// MISENEW X1
		{ 0x30, 0x02, 0x0400 },	// X1 ASITO
		{ 0x30, 0x03, 0x0400 },	// 
		{ 0x30, 0x04, 0x0800 },	// X1 BOSS10
		{ 0x31, 0x01, 0x0400 },	// X1 BUBI
		{ 0x31, 0x02, 0x0400 },	// BOSS CLEAR FOR
		{ 0x31, 0x03, 0x0400 },	// X1 END
		{ 0x31, 0x04, 0x0400 },	// X1 FAMI
		{ 0x31, 0x05, 0x0400 },	// X1 ISU
		{ 0x32, 0x01, 0x0800 },	// X1 MAPTES
		{ 0x32, 0x03, 0x0c00 },	// message02
		{ 0x33, 0x01, 0x0400 },	// MURA X1
		{ 0x33, 0x02, 0x0400 },	// X1 OMISE
		{ 0x33, 0x03, 0x0800 },	// PRO X1
		{ 0x33, 0x05, 0x0400 },	// SABAF X1
		{ 0x34, 0x01, 0x0800 },	// SENTO X1
		{ 0x34, 0x03, 0x0800 },	// TABIDACHI X1
		{ 0x34, 0x05, 0x0800 },	// USA OGAWA FLUTE
		{ 0x35, 0x02, 0x0400 },	// USA02 X1
		{ 0x35, 0x03, 0x1000 },	// USSR01 X1
		{ 0x36, 0x02, 0x0400 },	// YATTA X1
		{ 0x36, 0x03, 0x1000 },	// XZR PC-9801 FOR
		{ 0x37, 0x02, 0x1800 },	// XZR 6SEI TEST02
		{ 0x38, 0x03, 0x1800 },	// XZR HAPPYEND FOR
		{ 0x00, 0x00, 0x0000 },	// 
	};

	// Disk 1 (PSG)
	struct fpos md1b[] =
	{
		{ 0x0c, 0x02, 0x0400 },	// MISENEW PSG
		{ 0x0c, 0x03, 0x0400 },	// ASITOP
		{ 0x0c, 0x04, 0x0400 },	// 
		{ 0x0c, 0x05, 0x0800 },	// BOS10P
		{ 0x0d, 0x02, 0x0400 },	// BUBI
		{ 0x0d, 0x03, 0x0400 },	// BOSS CLEAR
		{ 0x0d, 0x04, 0x0400 },	// ENDPSG
		{ 0x0d, 0x05, 0x0400 },	// FAMIPS
		{ 0x0e, 0x01, 0x0400 },	// ISUPS
		{ 0x0e, 0x02, 0x0400 },	// MAP
		{ 0x0e, 0x03, 0x0400 },	// message02
		{ 0x0e, 0x04, 0x0400 },	// MSX MURA03
		{ 0x0e, 0x05, 0x0400 },	// OMIPS
		{ 0x0f, 0x01, 0x0400 },	// PROPS
		{ 0x0f, 0x02, 0x0400 },	// SABAPS
		{ 0x0f, 0x03, 0x0800 },	// 
		{ 0x0f, 0x05, 0x0400 },	// TABIDACHI
		{ 0x39, 0x04, 0x0400 },	// USA OGAWA FLUTE
		{ 0x39, 0x05, 0x1000 },	// SHINOBU URUSAI
		{ 0x3a, 0x04, 0x0c00 },	// XZR PC-9801
		{ 0x3b, 0x02, 0x0800 },	// XZR X1 PSG
		{ 0x3f, 0x03, 0x0c00 },	// APSG
		{ 0x42, 0x01, 0x0800 },	// USSPSG
		{ 0x47, 0x03, 0x0800 },	// 
		{ 0x00, 0x00, 0x0000 },	// 
	};

	if (argc < 2 || argc > 3)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	if (argc==3)
	{
		dn = atoi(argv[2]);
	}

	int numdisk = disk.GetNumDisk();
	for (int d=0; d<numdisk; d++) {
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x10);
		disk.ReadDATA1(0x00, 0x00, 0x00, 0x01, 0x01, buff, 0x13);
		disk.SetRecordRange(0x01,0x05);
		// IPL̕ŃfBXN𔻒
		if (!memcmp(&buff[1], id1, sizeof(id1)-1) || dn==1)
		{
			printf("DISK 1 F܂.\n");
			// CvO
			fcut("OPMDRV", 0x41, 0x20, 0x01, 0x01, 0x03, 0x0000, 0x1400);
			fcut("PSGDRV", 0x3a, 0x1d, 0x00, 0x01, 0x03, 0x0000, 0x0c00);

			// ȃf[^̐؂o
			for (i=0; md1a[i].sec; i++)
			{
				sprintf(fname,"MA0%02d",i);
				fcut(fname, md1a[i].trk, md1a[i].trk>>1, md1a[i].trk&1, md1a[i].sec, 0x03, 0x0000, md1a[i].size);
			}
			for (i=0; md1b[i].sec; i++)
			{
				sprintf(fname,"MB0%02d",i);
				fcut(fname, md1b[i].trk, md1b[i].trk>>1, md1b[i].trk&1, md1b[i].sec, 0x03, 0x0000, md1b[i].size);
			}
			continue;
		} 
	}
	return 0;
}

